// ExpressionProject::BioHazard.cpp

#include <windows.h>
#include <math.h>
#include "WindowsPrimer.h"
#include "materials.h"

LRESULT CALLBACK WindowProcedure( HWND, UINT, WPARAM, LPARAM);
void initGraphics( HWND hwnd, HDC hdc);
bool expressionBioHazard( double volume);
void drawLine( Point p1, Point p2);
void induce( double volume);
void scan( double state);
void polyApolymerase();
void line( Point p1, Point p2);
Point mirrorX( Point p);
Point roll( Point p, double angle);
double mysin( double t);
double mycos( double t);

HDC			hdc;
HDC			memdc;
HBITMAP		hbitmap;
HBRUSH		hbrush;
int			maxX, maxY;
int			pntX, pntY;
Point cap1a, cap1b, cap2a, cap2b, cap3a, cap3b, cap4a, cap4b;

ScriptCircleSuite suite1;
ScriptCircleSuite suite2;
ScriptCircleSuite suite3;
ScriptCircleSuite suite4;
ScriptCircleSuite suite5;
ScriptCircleSuite suite6;
ScriptCircleSuite suite7;

int WINAPI WinMain( HINSTANCE hThisInst, HINSTANCE hPrevInst,
				   LPSTR lpstrArgs, int nWinMode)
{	
	WindowsPrimer MyWindow(
							hThisInst,
							"MyWindow",
							WindowProcedure);
	MyWindow.windowReveal( "Windows95 Skelton by C++ original", nWinMode);
	//initGraphics( MyWindow.getHandle(), hdc);
	return MyWindow.reaction();
}

LRESULT CALLBACK WindowProcedure( HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT	paintstruct;

	switch( message) {
	case WM_CREATE :
		initGraphics( hwnd, hdc);
		expressionBioHazard( 11);
		break;
	case WM_WINDOWPOSCHANGED :
		maxX = GetSystemMetrics( SM_CXSCREEN);
		maxY = GetSystemMetrics( SM_CYSCREEN);
		pntX = maxX / 2;
		pntY = maxY / 2;
		break;
	case WM_PAINT :
		// get device context
		hdc = BeginPaint( hwnd, &paintstruct);
		// display virtual memory image
		BitBlt( hdc, 0, 0, maxX, maxY, memdc, 0, 0, SRCCOPY);
		// release device context
		EndPaint( hwnd, &paintstruct);
		break;
	case WM_CHAR :
		break;
	case WM_DESTROY:
		DeleteDC( memdc);
		DeleteObject( hbitmap);
		PostQuitMessage( 0);
		break;
	default:
		return DefWindowProc( hwnd, message, wParam, lParam);
	}
	return 0;
}

void initGraphics( HWND hwnd, HDC hdc)
{
	maxX = GetSystemMetrics( SM_CXSCREEN);
	maxY = GetSystemMetrics( SM_CYSCREEN);
	pntX = maxX / 2;
	pntY = maxY / 2;
	hdc = GetDC( hwnd);
	// zʐ
	memdc = CreateCompatibleDC( hdc);
	// rbg}bv
	//. Ȃ hbitmap = CreateCompatibleBitmap( hdc, maxX, maxY); ႟߂Ȃ́H
	hbitmap = CreateCompatibleBitmap( hdc, maxX, maxY);
	// rbg}bvzʂɐݒ
	SelectObject( memdc, hbitmap);
	// uV𐶐
	hbrush = (HBRUSH)GetStockObject( BLACK_BRUSH);
	// uVzʂɐݒ
	SelectObject( memdc, hbrush);
	// ݒ肳ꂽIuWFNgŉzʂhׂ
	//PatBlt( memdc, 0, 0, maxX, maxY, PATCOPY);
	PatBlt( memdc, 0, 0, maxX, maxY, PATCOPY);
}

bool expressionBioHazard( double volume)
{
	HPEN pen = CreatePen( PS_SOLID, 1, RGB( 255, 0, 0));
	if( pen == NULL)	PostQuitMessage( 0);
	SelectObject( memdc, pen);

	double RNAPolymerase = 26*volume;

	induce( volume);

	while( RNAPolymerase >= 0) {
		scan( RNAPolymerase);
		RNAPolymerase -= UNIT;
	}

	polyApolymerase();

	cap2a = suite3.P2;
	drawLine( cap1a, cap1b);
	drawLine( cap2a, cap2b);
	
	cap3a = suite4.P2;
	//cap4a = suite5.P2;
	//cap4b = suite7.P2;
	cap4a.x += 30;
	cap4b.x += 30;
	drawLine( cap3a, cap3b);
	drawLine( cap4b, cap4a);
	
	  
	// holizontal line (-300,-0)~( 300, 0)
	//MoveToEx( memdc, pntX-(-300), pntY-0, NULL);
	//LineTo( memdc, pntX-300, pntY-0);
	// vertical line ( 0, -300)~(0,300)
	//MoveToEx( memdc, pntX-0, pntY-(-300), NULL);
	//LineTo( memdc, pntX-0, pntY-300);
	
	DeleteObject( pen);

	return true;
}

void induce( double volume)
{
	// DNA dna( A, B, R, C1max, C1min, C2max, C2min)
	DNA gene1( 0, 11*volume,	15.0*volume,	26.0*volume,	8.543315113*volume,	15.0*volume,	2*volume);
	DNA gene2( 0, 15*volume,	10.5*volume,	25.5*volume,	15.00000000*volume,	10.5*volume,	2*volume);
	DNA gene3( 0, 15*volume,	10.5*volume,	15.0*volume,	4.547727520*volume,	10.5*volume,	volume	);
	DNA gene4( 0, 0,			13.5*volume,	13.5*volume,	10.56666667*volume, 13.5*volume,	0		);
	DNA gene5( 0, 0,			10.0*volume,	10.0*volume,	7.825000000*volume,	10.0*volume,	0		);
	DNA gene6( 0, 0,			3.00*volume,	2.828427125*volume,	0.000000000,		3.00*volume,	volume	);
	DNA gene7( 0, 15*volume,	9.50*volume,	10.56666667*volume,	7.825*volume ,	9.50*volume,	0		);

	suite1.aim( gene1, drawLine);
	suite2.aim( gene2, drawLine);
	suite3.aim( gene3, drawLine);
	suite4.aim( gene4, drawLine);
	suite5.aim( gene5, drawLine);
	suite6.aim( gene6, drawLine);
	suite7.aim( gene7, drawLine);

	cap1a = suite1.promoterON();
	cap1b = suite2.promoterON();
	suite3.promoterON();
	suite4.promoterON();
	suite5.promoterON();
	cap2b = suite6.promoterON();
	cap3b = suite7.promoterON();
}

void scan( double state)
{
	suite1.script( state);
	suite2.script( state);
	suite3.script( state);
	suite4.script( state);
	suite5.script( state);
	suite6.script( state);
	suite7.script( state);
}

void polyApolymerase()
{
	suite1.polyadenylation();
	suite2.polyadenylation();
	suite3.polyadenylation();
	suite4.polyadenylation();
	cap4a = suite5.polyadenylation();
	suite6.polyadenylation();
	cap4b = suite7.polyadenylation();
}

void drawLine( Point p1, Point p2)
{
	Point next1, next2;

	line( p1, p2);

	next1 = roll( p1, 120);
	next2 = roll( p2, 120);
	line( next1, next2);

	next1 = mirrorX( next1);
	next2 = mirrorX( next2);
	line( next1, next2);

	next1 = mirrorX( p1);
	next2 = mirrorX( p2);
	line( next1, next2);

	next1 = roll( next1, 120);
	next2 = roll( next2, 120);
	line( next1, next2);

	next1 = mirrorX( next1);
	next2 = mirrorX( next2);
	line( next1, next2);
}

void line( Point p1, Point p2)
{
	//MoveToEx( memdc, (int)(pntX + p1.x), (int)(pntY - p1.y), NULL);
	//LineTo( memdc, (int)(pntX + p2.x), (int)(pntY - p2.y));
	MoveToEx( memdc, round(pntX + p1.x), round(pntY - p1.y), NULL);
	LineTo( memdc, round(pntX + p2.x), round(pntY - p2.y));
}

Point mirrorX( Point p)
{
	Point mp( -p.x, p.y);
	return mp;
}

Point roll( Point p, double t)
{
	Point rp( p.x*mycos( t) - p.y*mysin(t), p.x*mysin( t) + p.y*mycos( t));
	return rp;
}

double mysin( double t) {
	return sin( t*3.141592653589790/180);
}

double mycos( double t) {
	return cos( t*3.141592653589790/180);
}

