// WindowsPrimer class

#include <windows.h>

class WindowsPrimer
{
protected :
	HWND		hwnd;
	MSG			msg;
	WNDCLASSEX	wcex;

public :
	WindowsPrimer();
	WindowsPrimer( HINSTANCE hMainInst, char *szWinName, WNDPROC WindowProcedure);
	void windowReveal( char *szTitle, int nWinMode);
	WPARAM	reaction();
	HWND getHandle();
};

// constructer
WindowsPrimer::WindowsPrimer(HINSTANCE hMainInst,
							 char *szWinName,
							 WNDPROC WindowProcedure)
{
	wcex.hInstance = hMainInst;
	wcex.lpszClassName = szWinName;
	wcex.lpfnWndProc = WindowProcedure;
	wcex.style = 0;
	wcex.cbSize = sizeof( WNDCLASSEX);
	wcex.hIcon = LoadIcon( NULL, IDI_APPLICATION);
	wcex.hIconSm = LoadIcon( NULL, IDI_APPLICATION);
	wcex.hCursor = LoadCursor( NULL, IDC_ARROW);
	wcex.lpszMenuName = NULL;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hbrBackground = (HBRUSH)GetStockObject( WHITE_BRUSH);

	if( !RegisterClassEx( &wcex))	return;
}

WindowsPrimer::WindowsPrimer()
{
}

void WindowsPrimer::windowReveal( char *szTitle, int nWinMode)
{
	hwnd = CreateWindow(
		wcex.lpszClassName,
		szTitle,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		HWND_DESKTOP,
		NULL,
		wcex.hInstance,
		NULL
		);
	ShowWindow( hwnd, nWinMode);
	UpdateWindow( hwnd);
}

WPARAM WindowsPrimer::reaction()
{
	while( GetMessage( &msg, NULL, 0, 0))
	{
		TranslateMessage( &msg);
		DispatchMessage( &msg);
	}
	return msg.wParam;
}

HWND WindowsPrimer::getHandle()
{
	return hwnd;
}
